diff --git a/src/include/realms.h b/src/include/realms.h
index 7a238d7137d..6dae8b4f85a 100644
--- a/src/include/realms.h
+++ b/src/include/realms.h
@@ -160,6 +160,7 @@ typedef struct home_pool_t {
 	home_server_t		*fallback;
 	int			in_fallback;
 	time_t			time_all_dead;
+	time_t			last_serviced;
 
 	int			num_home_servers;
 	home_server_t		*servers[1];
diff --git a/src/main/process.c b/src/main/process.c
index d286109c4df..70f70e6db78 100644
--- a/src/main/process.c
+++ b/src/main/process.c
@@ -639,6 +639,29 @@ static void request_done(REQUEST *request, int action)
 	 */
 	request->master_state = REQUEST_STOP_PROCESSING;
 
+#ifdef WITH_PROXY
+	/*
+	 *	Walk through the server pool to see if we need to mark
+	 *	connections as dead.
+	 */
+	if (request->home_pool) {
+		fr_event_now(el, &now);
+		if (request->home_pool->last_serviced < now.tv_sec) {
+			int i;
+
+			request->home_pool->last_serviced = now.tv_sec;
+
+			for (i = 0; i < request->home_pool->num_home_servers; i++) {
+				home_server_t *home = request->home_pool->servers[i];
+
+				if (home->state == HOME_STATE_CONNECTION_FAIL) {
+					mark_home_server_dead(home, &now);
+				}
+			}
+		}
+	}
+#endif
+
 #ifdef WITH_COA
 	/*
 	 *	Move the CoA request to its own handler.
